/*
hdlet.c Version 0.1.0  Hash delete record
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good insert */
/* return code 1 is record not found */

#include <bthash.h>

int hdlet(hashfmt *hshhdr, unsigned char *key)
   {
   long ofst;
   long hashofst;
   int rslt;
   int sigrslt;
   unsigned char *p,*q,*r;
   unsigned char *rcdptr;
   hshhdr->reason = 0;
   sigrslt = strcmp(hshhdr->signature,H_SIGNATURE);
   if (sigrslt)
      {
      fprintf(stderr,"hdlet: non-hash "
         "deletion\n");
      hshhdr->reason = HASH_ERR + 919;
      return(HASH_ERR + 919);
      } /* if non-hash delete */
   ofst = (long) hash(hshhdr,key);
   hashofst = ofst;
   hgetblk(hshhdr,ofst);
   if (hshhdr->reason) 
      {
      return(HASH_ERR + 903);
      }
   rcdptr = (unsigned char *) hshhdr->node;
   rslt = 999999;
   /* for each record in chain */
   /* starting with hash data space */
   while (1)
      {
      p = (unsigned char *) rcdptr
	 + hshhdr->rcdhdr
	 + hshhdr->keyofst;
      q = (unsigned char *) p + hshhdr->keylen;
      r = (unsigned char *) key;
      while (p < q)
	 {
	 rslt = *r - *p;
	 if (rslt) break;
	 p++;
	 r++;
	 } /* for each byte in key */
      if (!rslt)
	 {
	 /* record found: delete here */
	 if (ofst == hashofst)
	    {
	    if (hshhdr->node->next)
	       {
               long ovflofst;
	       ovflofst = hshhdr->node->next;
	       /* copy first overflow block */
	       /* to hashing address */
	       hgetblk(hshhdr,ovflofst);
	       if (hshhdr->reason)
                  return(HASH_ERR + 913);
	       hputblk(hshhdr,ofst,hshhdr->node);
	       if (hshhdr->reason)
                  return(HASH_ERR + 914);
	       /* put the first overflow */
	       /* record on the free stack */
	       ofst = ovflofst;
	       hshhdr->node->next =
	          hgetptr(hshhdr,hshhdr->fsofst);
	       if (hshhdr->reason)
                  return(HASH_ERR + 915);
	       hshhdr->freestk = ofst;
	       /* free block is all ff */
	       /* except for next pointer */
	       /* which was filled above */
	       p = (unsigned char *) hshhdr->rcd;
	       q = (unsigned char *) p + hshhdr->rcdlen;
	       while (p < q) *p++ = 0xff;
	       hputblk(hshhdr,ofst,hshhdr->node);
	       if (hshhdr->reason)
                  return(HASH_ERR + 916);
	       hputptr(hshhdr,hshhdr->fsofst,
	          hshhdr->freestk);
	       if (hshhdr->reason)
                  return(HASH_ERR + 917);
	       } /* if orphaned ovfl chain */
	    else
	       {
               hshhdr->node->next = (long) UINT_MAX;
	       p = (unsigned char *) hshhdr->rcd;
	       q = (unsigned char *) p + hshhdr->rcdlen;
	       while (p < q) *p++ = '\0';
	       hputblk(hshhdr,ofst,hshhdr->node);
	       if (hshhdr->reason)
	          {
                  return(HASH_ERR + 904);
	          } /* hputblk err */
	       } /* else no overflow chain */
	    } /* hashing area */
	 else
	    {
            long nextofst;
	    nextofst = hshhdr->node->next;
	    hshhdr->node->next =
	       hgetptr(hshhdr,hshhdr->fsofst);
	    if (hshhdr->reason)
               return(HASH_ERR + 905);
	    hshhdr->freestk = ofst;
	    /* free block is all ff */
	    /* except for next pointer */
	    /* which was filled above */
	    p = (unsigned char *) hshhdr->rcd;
	    q = (unsigned char *) p + hshhdr->rcdlen;
	    while (p < q) *p++ = 0xff;
	    hputblk(hshhdr,ofst,hshhdr->node);
	    if (hshhdr->reason)
               return(HASH_ERR + 906);
	    hputptr(hshhdr,hshhdr->fsofst,
	       hshhdr->freestk);
	    if (hshhdr->reason)
               return(HASH_ERR + 907);
	    hgetblk(hshhdr,hshhdr->ofstprev);
	    if (hshhdr->reason)
               return(HASH_ERR + 918);
	    hshhdr->node->next = nextofst;
	    hputblk(hshhdr,hshhdr->ofstprev,
	       hshhdr->node);
	    if (hshhdr->reason)
               return(HASH_ERR + 908);
	    } /* chain: fix link */
         return(DLETGOOD);
	 } /* rcd matched: delete */
      /* else not matched: walk chain */
      else if (hshhdr->node->next
         && hshhdr->node->next != UINT_MAX)
	 {
	 hshhdr->ofstprev = ofst;
	 ofst = hshhdr->node->next;
	 hgetblk(hshhdr,ofst);
         if (hshhdr->reason) 
            return(HASH_ERR + 909);
         rcdptr = (unsigned char *) hshhdr->node;
	 continue;
	 } /* not matched: walk chain */
      else break;
      } /* for each record in chain */
   if (hshhdr->node->next == UINT_MAX)
      {
      /* empty record: not found error */
      fprintf(stderr,"hdlet: empty record "
	 "found at hash address\n");
      fprintf(stderr,"delete key ");
      p = (unsigned char *) key;
      q = (unsigned char *) p + hshhdr->keylen;
      while (p < q)
	 fprintf(stderr,"%c", *p++);
      fprintf(stderr,"\n");
      hshhdr->reason = HASH_ERR + 910;
      return(NOTFOUND);
      } /* empty record: not found error */
   else
      {
      /* end of chain: not found error */
      fprintf(stderr,"hdlet: end of chain: "
	 "record not found\n");
      fprintf(stderr,"delete key ");
      p = (unsigned char *) key;
      q = (unsigned char *) p + hshhdr->keylen;
      while (p < q)
	 fprintf(stderr,"%c", *p++);
      fprintf(stderr,"\n");
      hshhdr->reason = HASH_ERR + 911;
      return(NOTFOUND);
      } /* end of chain: not found error */
   hshhdr->reason = HASH_ERR + 912;
   return(HASH_ERR + 912);
   } /* hdlet */
